require 'safe_colorize'

module Gpr
  module Commands
    class Get < Base
      using SafeColorize

      def initialize(thor)
        thor.class_eval do
          desc 'get', 'Get a repository'
          def get(param)
            host, user, repository =
              param.match(/.+(\/\/|@)(.+)\.git$/)[2].split(/(:|\/)/).delete_if.with_index {|_c, index| index.odd? }
            path = "#{::Gpr::APP_PATH}/#{host}/#{user}/#{repository}"

            if Dir.exist?(path)
              puts "#{'Warning'.color(:red).style(:underscore)}: #{user}/#{repository} already registered"
              return
            end

            `git clone #{param} #{path}`
          rescue NoMethodError
            raise InvalidRepositoryError, "invalid repository format `#{param}`"
          end
        end
      end
    end
  end
end
