require 'safe_colorize'

module Gpr
  module Commands
    class List < Base
      using SafeColorize

      def initialize(thor)
        thor.class_eval do
          desc 'list', 'Show all registered repositories'
          option :paths, type: :boolean, desc: 'Show the paths of all registered repositories'
          def list
            repositories = repository_list
            if options[:paths]
              repositories.each do |repository|
                puts repository
              end
            else
              repositories.each do |repository|
                repo_info = parse_repository(repository)

                puts "#{repo_info[:host].color(:yellow)} - #{repo_info[:repository].color(:blue)}"
              end
            end
          end
        end
      end
    end
  end
end
